#include "extern.h"

Node *comm_ForallStmt(root)
Node *root;
{
    Node *astmt = root->ForallStmt.Stmt;
    Node *var, *expr;
    T_Entry *entry;
    struct S_OptScalarMaskExpr *osme;
    Node *triplet, *temp;


    var  = astmt->AssignementStmt.Variable;
    expr = astmt->AssignementStmt.Expr;
    distribute_loop_forall(root);

    nelements = 0;
    Assg_elements[nelements]= var;
    nelements++;
    find_communication_elements ( expr);
    
    tag_var (root);
    make_global_dist_index(root);
    tag_communication_elements (root);
    root=generate_communication (root); 
    return root;
}

/* mark left hand side; If it is constant and distributed it has to be masked
   for example
           forall(i=1:N) a(i,2)=5
    and a is distributed at two dim 
           do i=1,N/P
              if owner(2,2)
                 a(i,local(2))=5
              end if
           end do
*/

tag_var (root)
Node *root;

{ 
  Node  *var=Assg_elements[0];
  Node *sub1,*temp1, *Name;
  int j,k;
  
  k =0;
  j =0;
  for(LIST_LOOP(sub1, list_invert(var->ArraySection.SubscriptList),temp1)) {
          sub1->com.typ = typ_malloc();
      if((Name=has_loop_index(sub1,root))!=NN) {
  if(U_strcmp_nocase (sub1->Subscript.Expr->com.str,Name->com.str)) { 
/* SIL     if(U_strcmp_nocase (sub1->Subscript.Expr->DumExpr.Expr1->com.str,Name->com.str)) { */
                          printf("I didnot implemented random write (gather ) yet\n");
        	  }
            else   
/*
   you know at this point   A(I, so you can distribute I same way as first dimension of A
   For example, A(BLOCK) on 4 processors, I will distribute same way.
*/            {
                index_dist[k].Name=Name;
                index_dist[k].dim=pdim(var->com.str,j);
                index_dist[k].dist=pdist(var->com.str,j);
                k++;
	      }
	  }
       else
           if(pdim(var->com.str,j)!= -1) sub1->com.typ->ctag = SINGLE;
       j++;
       }
}


/*
   this part will tag ths communication element;
   loop index is distributed (maybe not), it knows how it distributed from loop index Name
   it try to do some collective communication pater_matching by loop index and subscript of
   rhs array elements
*/

tag_communication_elements (root)
Node *root;

{ 
  Node *ele, *var=Assg_elements[0];
  Node *sub1, *temp1,*Name;
  int i,k,tag;
  
  for(i=1; i < nelements; i++) {
      ele = Assg_elements[i];
      k= 0;
      for(LIST_LOOP(sub1, list_invert(ele->ArraySection.SubscriptList),temp1)) {
          Name=has_loop_index(sub1,root);
          tag=pattern_match(Name, sub1, ele, k);
          sub1->com.typ = typ_malloc();
          sub1->com.typ->ctag=tag;
/*          printf("%d dimension of %s is taged %d as\n",
           k, ele->com.str,
           sub1->com.typ->ctag); */
          k++;
      }
  }
}


/* return loop index name inside sub, if thre is not retuns NULL */

Node *has_loop_index(sub,root)
Node *sub, *root;
{
  Node *tripletspec, *temp;
  struct S_ForallTripletSpec *triplet;

  for (LIST_LOOP (tripletspec, list_invert(root->ForallStmt.ForallTripletSpecList), temp)) {
   triplet = &tripletspec->ForallTripletSpec;
/*   if(triplet==NN) return NN;*/
   if (misc_is_name_in_tree (triplet->Name->com.str, sub))
        return triplet->Name;
 }
 return NN;
}

 
/* Name index distribution is known from index_dist[i][1] tells about which dimension of template
   it is aligned. index_dist[i][2] tels about BLOCK or CYCLIC
   for example forall(i=1:N)
                   a(i) =b(i+c) +x(i)
   a(i) is BLOCK distributed on P processor so loop index i is also BLOCK distributed
   After these fact if any of communication elements uses this index has to know these
   For example, x is replicated , it is converted to x(l_g(i))
   if b distribution is same as i, only shift operation is need 
          Name     sub             tag     
           i        i         NOCOMM or CONCAT
           i        i+c       NOCOMM or SHIFT
           i        i-c       NOCOMM or SHIFT
           i        c         NOCOMM or BROADCAST
           i        f(i)      NOCOMM or IRREGULAR
  
*/
                    
pattern_match(Name, sub, ele, k)
Node *Name, *sub, *ele;
int k;
{
 int tag;
  
 if (Name == NN) {
        if(pdim(ele->com.str,k) != -1) 
          tag = BROADCAST;
        else 
          tag = NOCOMM;
        return tag;
      }

  /* if both of them are BLOCK distribute */
 if ( (dist(Name) == 1) && (pdist(ele->com.str,k)==1)) {
     /* if both of them aligned at same dimension */
     if(idim(Name) == pdim(ele->com.str,k)) {
           if(tree_eq(Name,sub->Subscript.Expr))
              tag = NOCOMM;
         
           else if(shift(Name,sub)) 
              tag = SHIFT;
           else
              tag = IRREGULAR;
	 }

     /* if they are not aligned at same dimension it has to turn */
     else 
          if(tree_eq(Name,sub->Subscript.Expr))
               tag = ROTATE;
          else
              tag = IRREGULAR;
   return tag;
   }
  
 /* if Name is not DISTRIBUTED,  and sub is distribute BLOCK */

   if((dist(Name) == 0) && (pdist(ele->com.str,k)==1)) {
          if(tree_eq(Name,sub->Subscript.Expr))
               tag = CONCAT;
          else
               tag = IRREGULAR;
        return tag;
	}

 /* If Name is DISTRIBUTED block, but sub is not */
   if((dist(Name) == 1) && (pdist(ele->com.str,k)==0)) {
          tag = NOCOMM;
          return tag;
   }
   
 /* Both of them are not DISTRIBUTED */
   if((dist(Name) == 0) && (pdist(ele->com.str,k)==0)) {
          tag = NOCOMM;
          return tag;
}

printf("Some thing is wrong in pattern_match\n");
return NOTAG;
    
}

shift(Name,sub)
Node *Name, *sub;
{
 return 0;
}
 

dist(Name)
Node *Name;
{
 int i;
 for(i=0; i < 7; i++)
    if(tree_eq(index_dist[i].Name, Name))
               return index_dist[i].dist;
 return 0;
}

idim(Name)
Node *Name;
{
 int i;
 for(i=0; i < 7; i++)
    if(tree_eq(index_dist[i].Name, Name))
               return index_dist[i].dim;
 return -1;
}

Node *generate_communication (root)
Node *root;
{
  Node *ele, *count;
  int i, parti_called;
  Node *stmt, *expr;
 
  count=get_int_temp();
  expr = make_DumExpr_1_PIN ( make_IntegerConstant (1));
  stmt = make_AssignementStmt (count,expr); 
  root->com.trans = trans_add_stmt_bef(root->com.trans, stmt);  
  parti_called = 0;
  for(i=1;i<nelements; i++){
      ele = Assg_elements[i];     
/*      if(is_broadcast_need(ele))
           forall_broadcast_1(ele,root);
      else */
          if(is_comm_need(ele)) {
                 parti_called = 1;
                 parti(ele,root,count);
	       }
    }

  if(parti_called) {
     expr = make_DumExpr_PIN (count, &Plus, make_IntegerConstant (1));
     stmt = make_AssignementStmt (count,expr); 
     root->com.trans = trans_add_stmt_aft(root->com.trans, stmt);
   }
  recycle(count);
  return root;
}

is_broadcast_need(ele)
Node *ele;
{
  Node *sub, *temp; 
  for(LIST_LOOP(sub, list_invert(ele->ArraySection.SubscriptList),temp)) 
    if(sub->com.typ->ctag==BROADCAST) {
                                  if(zb_template_rank==1) 
                                                     return 1;
				}
  return 0;
}

is_comm_need(ele)
Node *ele;
{
  Node *sub, *temp; 
  for(LIST_LOOP(sub, list_invert(ele->ArraySection.SubscriptList),temp)) 
    if(sub->com.typ->ctag!=NOCOMM) return 1;
  return 0;
}

parti(ele, root, count)
Node *ele, *root, *count;
{
 Node *forallstmt, *ifstmt, *stmt, *dostmt;
 Node *ischedinfo, *buffer;
 Node *block;
 Node *astmt = root->ForallStmt.Stmt;
 Node *expr;
 Node *sublist;
 int is_make_if;

  is_make_if = 0;
  if(is_only_index_dependet(ele,root))is_make_if=1;
  expr = astmt->AssignementStmt.Expr;
  block = make(BLOCK);
  block_push (block);
  BLOCK_ADD_STMTS_TO (block->Block.Block); 
  ischedinfo=get_int_temp();
 forallstmt=tree_dup(root);
 forallstmt->ForallStmt.Stmt=NN; 
 make_sub_global(ele,root);
 dostmt = forall_to_do(forallstmt,ele, ischedinfo);
 if(is_make_if)
       stmt=make_if(dostmt);
 else stmt = dostmt;
 block_add_stmt(stmt);
 buffer=gather(ele,ischedinfo);
 sublist = buffer->ArraySection.SubscriptList;
 sublist->SubscriptList.Subscript = count;
 astmt->AssignementStmt.Expr = change_expr_with_temp(expr,ele,buffer);
 block =  block_pop();
 root->com.trans = trans_add_stmt_bef (root->com.trans, block); 

}

Node *make_if(forallstmt)
Node *forallstmt;
{
 Node *ifstmt, *ifendstmt;
 Node *ifc, *ifc1;
 struct S_IfConstruct *sifc;
 Node *block, *first;
 Etype *etype;
 Typ *typ;
 Node *dummy;
 Node *stmt;


  block = make(BLOCK);
  block_push (block);
  BLOCK_ADD_STMTS_TO (block->Block.Block); 

  etype = Etype_LOGICAL_0;  
  typ = typ_malloc();
  typ->etype=etype;
  first=temp_make(typ,1,&dummy);
  stmt = make_AssignementStmt (first,make_LogicalConstant (".TRUE."));
  block_add_stmt(stmt);

 ifstmt = make ( IF_THEN_STMT);
 ifstmt->IfThenStmt.If = &If;
 ifstmt->IfThenStmt.Lp=&Lp;
 ifstmt->IfThenStmt.Expr=first;
 ifstmt->IfThenStmt.Rp=&Rp;
 ifstmt->IfThenStmt.Name=Node_Then;
 ifendstmt= make( END_IF_STMT);
 ifendstmt->EndIfStmt.EndIf = &EndIf;

 ifc = make ( IF_CONSTRUCT); 
 block_push(ifc);
 BLOCK_ADD_STMTS_TO(ifc->IfConstruct.IfBlock);
 ifc->IfConstruct.IfThenStmt = ifstmt;
 block_add_stmt(forallstmt);
  stmt = make_AssignementStmt (first,make_LogicalConstant (".FALSE."));
  block_add_stmt(stmt);

 ifc1= block_pop();
 sifc=&ifc1->IfConstruct;
 sifc->EndIfStmt = ifendstmt;
 block_add_stmt(sifc);


 block =  block_pop();
 return block;
/*
 ifc->IfConstruct.IfBlock = forallstmt;
 BLOCK_ADD_STMTS_TO (ifc->IfConstruct.IfBlock); 
 ifc->IfConstruct.EndIfStmt=ifendstmt;
 ifc->IfConstruct.ElseIfStmtBlockList=NN;
 ifc->IfConstruct.ElseStmt=NN;
 ifc->IfConstruct.ElseBlock=NN;
 return ifc;
 forallstmt->com.trans = trans_add_stmt_bef (forallstmt->com.trans, ifstmt); 
 forallstmt->com.trans = trans_add_stmt_aft (forallstmt->com.trans, ifendstmt); 
 return forallstmt;
*/
 

}

Node *forall_to_do(node,ele,ischedinfo)
Node *node, *ele , *ischedinfo;
{
  Node *block, *block1;
  Node *count, *coord;
  Node *local, *procs;
  block = make(BLOCK);
  block_push (block);
  BLOCK_ADD_STMTS_TO (block->Block.Block); 
  count = get_int_temp();
  initialize(count);

      /* do inside of LOOPS as block1 */
      block1 = make(BLOCK);
      block_push (block1);
      BLOCK_ADD_STMTS_TO (block1->Block.Block); 
      coord=fill_coord_parti(ele);
      procs=fill_procs_parti(coord,count);
      local=fill_local_parti(ele,count,coord);
      increment(count);
      block1 = block_pop();
      node->ForallStmt.Stmt=block1;

  block_add_stmt(node);
  decrement(count);
/*  ischedinfo=ifschedule(local,procs,count);*/
  ifschedule(local,procs,count,ischedinfo);
  recycle(local);recycle(procs);recycle(count); /*recycle(coord);*/
  block =  block_pop();
  return block; 
}

/* this part create a coord array with template size
   one dimentional array and store logical processor name in the coord */

Node *fill_coord_parti(ele)
Node *ele;
{
  Etype *etype;
  Node *coord;
  Node *stmt, *stmt1,*temp, *sub, *sub1, *expr;
  Node *sublist;
  int k;

  etype = Etype_INTEGER_0;
  coord = temp_for_parti(etype,zb_template_rank);
  coord = tree_dup(coord);
  coord->com.typ->shape->rank=0;
  k=0;
  for(LIST_LOOP(sub, list_invert(ele->ArraySection.SubscriptList),temp)) {
  if(pdist(ele->com.str,k)==1) {
     sub1=make_Subscript( make_IntegerConstant (pdim(ele->com.str,k)+1),NN,NN);
     sublist=  coord->ArraySection.SubscriptList;
     sublist->SubscriptList.Subscript = sub1;
     expr = global_to_proc(sub->Subscript.Expr,pdim(ele->com.str,k)); 
     stmt = make_AssignementStmt (coord,expr);
     stmt1=tree_dup(stmt);
     block_add_stmt(stmt1);
   }
  k++;
 }
  return coord;
}

/* this part is to call express routine to convert coord logical 
   processor into physical processors */

Node *fill_procs_parti(coord,count)
Node *coord, *count;

{
  Etype *etype;
  Node *stmt, *stmt1;
  Node *sublist, *sub, *sub1;
  Node *procs, *function;
  T_Entry *entry;
  struct S_FunctionReference *fun;
/* makes procs(count) */

  etype = Etype_INTEGER_0;
  procs = temp_for_parti(etype,psize);
  procs=tree_dup(procs);
  procs->com.typ->shape->rank=0;
  sub=make_Subscript( count,NN,NN);
  sublist=  procs->ArraySection.SubscriptList;
  sublist->SubscriptList.Subscript = sub;

/* makes KXGDPR(coord)  */

  function=make(FUNCTION_REFERENCE);
  function->FunctionReference.Name = make_Name("KXGDPR");
  function->FunctionReference.Lp = &Lp;
  sublist=function->FunctionReference.SubscriptList=make (SUBSCRIPT_LIST);
  sublist->SubscriptList.Subscript = 
       make_Subscript( make_Name(coord->com.str),NN,NN);
  function->FunctionReference.Rp = &Rp;
  function->com.str="KXGDPR";
  
  entry = install_glo ("KXGDPR", TAB_NAME, 0);
  SET_intrinsic (entry);
  SET_elemental (entry);
  SET_f77_intrinsic (entry);
  fun= &function->FunctionReference;
  fun->entry = entry;

/* add the block */   
  stmt = make_AssignementStmt (procs,function); 
  block_add_stmt(stmt);  
  return procs;
}


Node *fill_local_parti(ele,count,coord)
Node *ele, *count, *coord;

{
  Etype *etype;
  Node *stmt, *stmt1;
  Node *sublist, *sub, *sub1, *temp;
  Node *local;
  T_Entry *entry;
  Node *term, *expr, *oldexpr, *local_size, *sizes, *oldsizes, *term0;
  int i,k,l,first,rank;

/* at this point all sub are global. it has to converted to local 
   if ele at that sub distributed. */

  k = 0;
  for(LIST_LOOP(sub, list_invert(ele->ArraySection.SubscriptList),temp)) {
      if(pdist(ele->com.str,k)==1)
             sub->Subscript.Expr = 
         new_global_to_local(sub->Subscript.Expr,pdim(ele->com.str,k),coord);
      k++;
    }

/* makes local(count) */

  etype = Etype_INTEGER_0;
  local = temp_for_parti(etype,psize);
  local = tree_dup(  local);
  local->com.typ->shape->rank=0;
  sub=make_Subscript( count,NN,NN);
  sublist=  local->ArraySection.SubscriptList;
  sublist->SubscriptList.Subscript = sub;

/* local(count)= sub1+sub2*size1 +sub3*size1*size3  */
  entry = lookup_loc(ele->com.str);
  rank = entry->local_shape->rank;
  first=1;  
  k=0;
  for(LIST_LOOP(sub, list_invert(ele->ArraySection.SubscriptList),temp)) {
      if(first)
         expr = make_DumExpr_1_PIN (sub->Subscript.Expr);
      else {
           l=0;
           for(i=k;i<rank; i++) {
              local_size=entry->local_shape->extent[l];
              if(i==k) 
                sizes= make_DumExpr_1_PIN (local_size);
              else 
                sizes = make_DumExpr_PIN (oldsizes, &Times, local_size);
              oldsizes = sizes;
             l++;
            }
           term0 = make_DumExpr_PIN (sub->Subscript.Expr, &Minus, Node_1);
           term = make_DumExpr_PIN (term0, &Times, sizes);
           expr = make_DumExpr_PIN (oldexpr, &Plus, term);
          }
       oldexpr = expr;
       first=0;   
       k++;
    }
        
/* add the block */   
  stmt = make_AssignementStmt (local,expr); 
  block_add_stmt(stmt);  
  return local;
}

increment(count)
Node *count;
{
 Node *stmt, *expr;
 expr = make_DumExpr_PIN (count, &Plus, make_IntegerConstant (1));
 stmt = make_AssignementStmt (count,expr); 
 block_add_stmt(stmt);  
}

decrement(count)
Node *count;
{
 Node *stmt, *expr;
 expr = make_DumExpr_PIN (count, &Minus, make_IntegerConstant (1));
 stmt = make_AssignementStmt (count,expr); 
 block_add_stmt(stmt);  
}

initialize(count)
Node *count;
{
 Node *stmt, *expr;
 expr = make_DumExpr_1_PIN (make_IntegerConstant (1));
 stmt = make_AssignementStmt (count,expr); 
 block_add_stmt(stmt);  
}

ifschedule(local,procs,count,ischedinfo)
Node *local, *procs, *count, *ischedinfo;
{
  Etype *etype;
  Node *stmt, *stmt1;
  Node *function;
  T_Entry *entry;
  struct S_FunctionReference *fun;
  Node *valum[3];
/* makes ifscehdule(local,procs,count)  */

  function=make(FUNCTION_REFERENCE);
  function->FunctionReference.Name = make_Name("IFSCHEDULE");
  function->FunctionReference.Lp = &Lp;

  valum[0]= make_Subscript( make_Name(local->com.str),NN,NN);
  valum[1]= make_Subscript( make_Name(procs->com.str),NN,NN);
  valum[2]= make_Subscript( make_Name(count->com.str),NN,NN);

  function->FunctionReference.SubscriptList=make_List(valum, 3,SUBSCRIPT_LIST);
  function->FunctionReference.Rp = &Rp;
  function->com.str="IFSCHEDULE";
  
  entry = install_glo ("IFSCHEDULE", TAB_NAME, 0);
  SET_intrinsic (entry);
  SET_elemental (entry);
  SET_f77_intrinsic (entry);
  fun= &function->FunctionReference;
  fun->entry = entry;

/*  ischedinfo = get_int_temp();*/
   
/* add the block */   
  stmt = make_AssignementStmt (ischedinfo,function); 
  block_add_stmt(stmt);  
/*  return ischedinfo;*/
}

Node *gather(ele,ischedinfo)
Node *ele,*ischedinfo;
{
  Etype *etype;
  Node *stmt, *Name, *Name1, *Name2, *Name3;
  Node *sublist, *buffer;
  T_Entry *entry;
  Node *valum[3];
  char *fname,*short_type;
  

  etype = ele->com.typ->etype;
  buffer = temp_for_parti(etype,psize);
  buffer = tree_dup(  buffer);
  buffer->com.typ->shape->rank = 0;

  
  fname=(char*) U_malloc (40);
  short_type = mac_etype_short_name(ele->com.typ->etype);
  if(!strcmp(short_type,"R"))
     sprintf(fname, "%sFGATHER","D");
  else
     sprintf(fname, "%sFGATHER",short_type);

/* makes gather(ischedinfo,buffer,aloc)  */


  Name1=make_Name(ischedinfo->com.str);
  Name1->com.typ = typ_malloc();
  Name1->com.typ->etype = Etype_CHARACTER_0;
  valum[0]= make_Subscript(Name1,NN,NN);
  Name2=make_Name(buffer->com.str);
  Name2->com.typ = typ_malloc();
  Name2->com.typ->etype = Etype_CHARACTER_0;
  valum[1]= make_Subscript( Name2,NN,NN);
  Name3=make_Name(ele->com.str);
  Name3->com.typ = typ_malloc();
  Name3->com.typ->etype = Etype_CHARACTER_0;
  valum[2]= make_Subscript( Name3,NN,NN);

  sublist=make_List(valum, 3,SUBSCRIPT_LIST);
  if(!(entry=lookup_glo(fname)) )  
      entry = install_glo (fname, TAB_NAME, 0);

/* add the block */   
  Name =make_Name(fname);
  stmt = make_CallStmt (Name,sublist); 
  block_add_stmt(stmt);  
  return buffer;
}



Node *get_int_temp()
{
  Etype *etype;
  Typ *typ;
  Node *dummy;
  Node *temp;
  etype = Etype_INTEGER_0;  
  temp = search(etype,0);
  if(temp==NN) {
      typ = typ_malloc();
      typ->etype=etype;
      temp = temp_make(typ,1,&dummy);
    }
  return temp;
}

find_parti_size(var)
Node *var;
{
 T_Entry *entry;
 long value;
 Node *expr;
 entry=lookup_loc(var->com.str);
 expr=typ_shape_size(entry->local_shape);
 if (expr_is_constant_int (expr, &value)){
       if(value > (long) psize) psize= (int) value;
     }
 else printf("It can not find local shape of forall var\n");
} 

